package sun.java2d.d3d;

import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.loops.Blit;
import java.awt.geom.AffineTransform;
import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.loops.CompositeType;
import sun.java2d.loops.SurfaceType;
import sun.java2d.SurfaceData;
import java.lang.ref.WeakReference;
import sun.java2d.loops.TransformBlit;

final class D3DGeneralTransformedBlit extends TransformBlit
{
    private final TransformBlit performop;
    private WeakReference<SurfaceData> srcTmp;
    
    D3DGeneralTransformedBlit(TransformBlit performop) {
        super(SurfaceType.Any, CompositeType.AnyAlpha, D3DSurfaceData.D3DSurface);
        this.performop = performop;
    }
    
    @Override
    public synchronized void Transform(SurfaceData convert, SurfaceData surfaceData, Composite composite, Region region, AffineTransform affineTransform, int n, int srcX, int srcY, int n2, int n3, int w, int h) {
        Blit fromCache = Blit.getFromCache(convert.getSurfaceType(), CompositeType.SrcNoEa, SurfaceType.IntArgbPre);
        SurfaceData dstData = (this.srcTmp != null) ? ((SurfaceData)this.srcTmp.get()) : null;
        convert = GraphicsPrimitive.convertFrom(fromCache, convert, srcX, srcY, w, h, dstData, 3);
        this.performop.Transform(convert, surfaceData, composite, region, affineTransform, n, 0, 0, n2, n3, w, h);
        if (convert != dstData) {
            this.srcTmp = new WeakReference(convert);
        }
    }
}
